﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FixPoseChannels
{
    class PoserItem
    {
        public string ItemName; // only meaningful for joints
        public string InternalName;
        public string DisplayName;
    }

    class PoserActor
    {
        public string InternalName;
        public string DisplayName;
        public List<PoserItem> Channels;

        public PoserActor()
        {
            Channels = new List<PoserItem>();
        }
    }

    class PoserFigure
    {
        public List<PoserActor> Actors;

        public PoserFigure()
        {
            Actors = new List<PoserActor>();
        }

        public string LookForAlternate(PoseFix fix)
        {
            foreach (PoserActor actor in Actors)
            {
                // This has to match
                if (actor.InternalName == fix.Actor)
                {
                    foreach (PoserItem item in actor.Channels)
                    {
                        // Signal to the caller that they don't need to do anything
                        if (item.InternalName == fix.Channel) return null;

                        // Signal to the caller that the pose-writer fucked up.
                        if (item.DisplayName == fix.Channel) return item.InternalName;

                        // Signal to the caller that the pose-writer TOTALLY fucked up.
                        if (item.ItemName == fix.Channel) return item.InternalName;
                    }
                }
            }

            // If we couldn't find it at all, just punt.
            return null;
        }

    

        public string UpdateDisplayName(PoseFix fix)
        {
            foreach (PoserActor actor in Actors)
            {
                // This has to match
                if (actor.InternalName == fix.Actor)
                {
                    foreach (PoserItem item in actor.Channels)
                    {
                        // Has to match by InternalName
                        if (item.InternalName == fix.Channel)
                        {
                            item.DisplayName = fix.Name;
                        }
                    }
                }
            }

            // If we couldn't find it at all, just punt.
            return null;
        }
    }


    class PoseFix
    {
        public string Figure;
        public string Actor;
        public string Channel;
        public string Name;
    }
}
